--[[----------------------------------------------------------------------------
Coordinated Universal Time (UTC)
------------------------------------------------------------------------------]]
local addonName, addon = ...

local portal = GetCVar('portal'):upper()

local realmOffsetUTC = portal == 'EU' and 1 or ({
	["Aegwynn"]				= -6,
	["Agamaggan"]			= -6,
	["Aggramar"]			= -6,
	["Akama"]				= -6,
	["Alexstrasza"]			= -6,
	["Alleria"]				= -6,
	["Altar of Storms"]		= -5,
	["Alterac Mountains"]	= -5,
	["Aman'thul"]			= 10,
	["Andorhal"]			= -5,
	["Anetheron"]			= -5,
	["Anub'arak"]			= -5,
	["Archimonde"]			= -6,
	["Area 52"]				= -5,
	["Argent Dawn"]			= -5,
	["Arthas"]				= -5,
	["Arygos"]				= -5,
	["Auchindoun"]			= -5,
	["Azgalor"]				= -6,
	["Azjol-Nerub"]			= -7,
	["Azralon"]				= -6,
	["Azshara"]				= -5,
	["Balnazzar"]			= -6,
	["Barthilas"]			= 10,
	["Black Dragonflight"]	= -5,
	["Blackhand"]			= -6,
	["Bleeding Hollow"]		= -5,
	["Blood Furnace"]		= -6,
	["Bloodhoof"]			= -5,
	["Bloodscalp"]			= -7,
	["Borean Tundra"]		= -6,
	["Burning Blade"]		= -5,
	["Burning Legion"]		= -6,
	["Caelestrasz"]			= 10,
	["Cairne"]				= -6,
	["Cho'gall"]			= -6,
	["Chromaggus"]			= -6,
	["Dalaran"]				= -5,
	["Dalvengyr"]			= -5,
	["Darkspear"]			= -7,
	["Dath'Remar"]			= 10,
	["Dawnbringer"]			= -6,
	["Deathwing"]			= -7,
	["Demon Soul"]			= -5,
	["Dentarg"]				= -5,
	["Detheroc"]			= -6,
	["Doomhammer"]			= -7,
	["Drak'Tharon"]			= -6,
	["Drak'thul"]			= -6,
	["Draka"]				= -6,
	["Drakkari"]			= -6,
	["Dreadmaul"]			= 10,
	["Drenden"]				= -5,
	["Durotan"]				= -5,
	["Duskwood"]			= -5,
	["Earthen Ring"]		= -5,
	["Eitrigg"]				= -6,
	["Eldre'Thalas"]		= -5,
	["Elune"]				= -5,
	["Emerald Dream"]		= -6,
	["Eonar"]				= -5,
	["Eredar"]				= -5,
	["Executus"]			= -5,
	["Exodar"]				= -5,
	["Farstriders"]			= -6,
	["Fenris"]				= -5,
	["Firetree"]			= -5,
	["Fizzcrank"]			= -6,
	["Frostmane"]			= -6,
	["Frostmourne"]			= 10,
	["Gallywix"]			= -6,
	["Garithos"]			= -6,
	["Garona"]				= -6,
	["Garrosh"]				= -5,
	["Ghostlands"]			= -6,
	["Gilneas"]				= -5,
	["Goldrinn"]			= -6,
	["Gorefiend"]			= -5,
	["Greymane"]			= -6,
	["Grizzly Hills"]		= -5,
	["Gul'dan"]				= -6,
	["Gundrak"]				= 10,
	["Hakkar"]				= -6,
	["Haomarush"]			= -5,
	["Hellscream"]			= -6,
	["Hydraxis"]			= -6,
	["Icecrown"]			= -7,
	["Illidan"]				= -6,
	["Jaedenar"]			= -5,
	["Jubei'Thos"]			= 10,
	["Kael'Thas"]			= -6,
	["Kargath"]				= -5,
	["Kel'Thuzad"]			= -7,
	["Khadgar"]				= -5,
	["Khaz Modan"]			= -6,
	["Khaz'goroth"]			= 10,
	["Kirin Tor"]			= -6,
	["Korgath"]				= -6,
	["Kul Tiras"]			= -6,
	["Laughing Skull"]		= -6,
	["Lightning's Blade"]	= -5,
	["Lightninghoof"]		= -6,
	["Llane"]				= -5,
	["Lothar"]				= -5,
	["Madoran"]				= -6,
	["Maelstrom"]			= -6,
	["Magtheridon"]			= -5,
	["Mal'Ganis"]			= -6,
	["Malfurion"]			= -6,
	["Malorne"]				= -6,
	["Malygos"]				= -6,
	["Mannoroth"]			= -5,
	["Medivh"]				= -5,
	["Mok'Nathal"]			= -6,
	["Moon Guard"]			= -6,
	["Mug'thol"]			= -6,
	["Muradin"]				= -6,
	["Nagrand"]				= 10,
	["Nathrezim"]			= -7,
	["Nazgrel"]				= -5,
	["Nemesis"]				= -6,
	["Nesingwary"]			= -6,
	["Norgannon"]			= -5,
	["Perenolde"]			= -7,
	["Quel'dorei"]			= -6,
	["Quel'Thalas"]			= -6,
	["Ragnaros"]			= -6,
	["Ravencrest"]			= -6,
	["Ravenholdt"]			= -5,
	["Rexxar"]				= -6,
	["Runetotem"]			= -6,
	["Sargeras"]			= -6,
	["Saurfang"]			= 10,
	["Scarlet Crusade"]		= -6,
	["Scilla"]				= -5,
	["Sen'jin"]				= -6,
	["Shadow Council"]		= -7,
	["Shadowmoon"]			= -5,
	["Shandris"]			= -5,
	["Shattered Hand"]		= -5,
	["Sisters of Elune"]	= -6,
	["Skullcrusher"]		= -5,
	["Smolderthorn"]		= -5,
	["Staghelm"]			= -6,
	["Steamwheedle Cartel"]	= -5,
	["Stormrage"]			= -5,
	["Stormreaver"]			= -6,
	["Tanaris"]				= -5,
	["Terenas"]				= -7,
	["Terokkar"]			= -6,
	["Thaurissan"]			= 10,
	["The Forgotten Coast"]	= -5,
	["The Underbog"]		= -6,
	["Thorium Brotherhood"]	= -6,
	["Thrall"]				= -5,
	["Thunderhorn"]			= -6,
	["Thunderlord"]			= -6,
	["Tol Barad"]			= -6,
	["Tortheldrin"]			= -5,
	["Trollbane"]			= -5,
	["Turalyon"]			= -5,
	["Twisting Nether"]		= -6,
	["Uldaman"]				= -5,
	["Undermine"]			= -5,
	["Vek'nilash"]			= -6,
	["Warsong"]				= -5,
	["Whisperwind"]			= -6,
	["Wildhammer"]			= -6,
	["Winterhoof"]			= -6,
	["Ysera"]				= -5,
	["Ysondre"]				= -5,
	["Zangarmarsh"]			= -7,
	["Zul'jin"]				= -5,
	["Zuluhed"]				= -5
})[GetRealmName()] or -8

local client, utc = date("*t"), date("!*t")
local delta = client.wday - utc.wday
local clientOffsetUTC = client.hour - utc.hour + ((delta > 1 and -24) or (delta < -1 and 24) or delta * 24)

local clientToRealmUTC, WDAY = (realmOffsetUTC - clientOffsetUTC) * 3600, portal ~= 'EU' and 3 or 4

function addon.GetResetLFR()
	local reset = date("*t", time() + clientToRealmUTC)
	local month, year = reset.month, reset.year
	local daysInMonth = 30 + (month ~= 2 and ((month <= 7 and month or month + 1) % 2) or (year % 4 ~= 0 or (year % 100 == 0 and year % 400 ~= 0)) and -2 or -1)
	reset.day = reset.day - reset.wday + ((reset.wday > WDAY or (reset.wday == WDAY and reset.hour >= 8)) and WDAY + 7 or WDAY)
	if reset.day > daysInMonth then
		reset.day = reset.day - daysInMonth
		if month < 12 then
			reset.month = month + 1
		else
			reset.month, reset.year = 1, year + 1
		end
	end
	reset.hour, reset.min, reset.sec, reset.wday, reset.yday = 8, 0, 0, nil, nil
	return time(reset) - clientToRealmUTC
end
